Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/dataanalysis.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs	(revision 7294)
@@ -9241,1183 +15547,446 @@
 
     }
-    public class mlpbase
+    public class mcpd
     {
-        public class multilayerperceptron
-        {
-            public int[] structinfo;
-            public double[] weights;
-            public double[] columnmeans;
-            public double[] columnsigmas;
-            public double[] neurons;
-            public double[] dfdnet;
-            public double[] derror;
-            public double[] x;
-            public double[] y;
-            public double[,] chunks;
-            public double[] nwbuf;
-            public multilayerperceptron()
-            {
-                structinfo = new int[0];
-                weights = new double[0];
-                columnmeans = new double[0];
-                columnsigmas = new double[0];
-                neurons = new double[0];
-                dfdnet = new double[0];
-                derror = new double[0];
-                x = new double[0];
-                y = new double[0];
-                chunks = new double[0,0];
-                nwbuf = new double[0];
+        /*************************************************************************
+        This structure is a MCPD (Markov Chains for Population Data) solver.
+
+        You should use ALGLIB functions in order to work with this object.
+
+          -- ALGLIB --
+             Copyright 23.05.2010 by Bochkanov Sergey
+        *************************************************************************/
+        public class mcpdstate
+        {
+            public int n;
+            public int[] states;
+            public int npairs;
+            public double[,] data;
+            public double[,] ec;
+            public double[,] bndl;
+            public double[,] bndu;
+            public double[,] c;
+            public int[] ct;
+            public int ccnt;
+            public double[] pw;
+            public double[,] priorp;
+            public double regterm;
+            public minbleic.minbleicstate bs;
+            public int repinneriterationscount;
+            public int repouteriterationscount;
+            public int repnfev;
+            public int repterminationtype;
+            public minbleic.minbleicreport br;
+            public double[] tmpp;
+            public double[] effectivew;
+            public double[] effectivebndl;
+            public double[] effectivebndu;
+            public double[,] effectivec;
+            public int[] effectivect;
+            public double[] h;
+            public double[,] p;
+            public mcpdstate()
+            {
+                states = new int[0];
+                data = new double[0,0];
+                ec = new double[0,0];
+                bndl = new double[0,0];
+                bndu = new double[0,0];
+                c = new double[0,0];
+                ct = new int[0];
+                pw = new double[0];
+                priorp = new double[0,0];
+                bs = new minbleic.minbleicstate();
+                br = new minbleic.minbleicreport();
+                tmpp = new double[0];
+                effectivew = new double[0];
+                effectivebndl = new double[0];
+                effectivebndu = new double[0];
+                effectivec = new double[0,0];
+                effectivect = new int[0];
+                h = new double[0];
+                p = new double[0,0];
             }
         };
 
 
-
-
-        public const int mlpvnum = 7;
-        public const int nfieldwidth = 4;
-        public const int chunksize = 32;
-
-
         /*************************************************************************
-        Creates  neural  network  with  NIn  inputs,  NOut outputs, without hidden
-        layers, with linear output layer. Network weights are  filled  with  small
-        random values.
+        This structure is a MCPD training report:
+            InnerIterationsCount    -   number of inner iterations of the
+                                        underlying optimization algorithm
+            OuterIterationsCount    -   number of outer iterations of the
+                                        underlying optimization algorithm
+            NFEV                    -   number of merit function evaluations
+            TerminationType         -   termination type
+                                        (same as for MinBLEIC optimizer, positive
+                                        values denote success, negative ones -
+                                        failure)
 
           -- ALGLIB --
-             Copyright 04.11.2007 by Bochkanov Sergey
+             Copyright 23.05.2010 by Bochkanov Sergey
         *************************************************************************/
-        public static void mlpcreate0(int nin,
-            int nout,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-
-            layerscount = 1+2;
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, false, network);
-        }
+        public class mcpdreport
+        {
+            public int inneriterationscount;
+            public int outeriterationscount;
+            public int nfev;
+            public int terminationtype;
+        };
+
+
+
+
+        public const double xtol = 1.0E-8;
 
 
         /*************************************************************************
-        Same  as  MLPCreate0,  but  with  one  hidden  layer  (NHid  neurons) with
-        non-linear activation function. Output layer is linear.
+        DESCRIPTION:
+
+        This function creates MCPD (Markov Chains for Population Data) solver.
+
+        This  solver  can  be  used  to find transition matrix P for N-dimensional
+        prediction  problem  where transition from X[i] to X[i+1] is  modelled  as
+            X[i+1] = P*X[i]
+        where X[i] and X[i+1] are N-dimensional population vectors (components  of
+        each X are non-negative), and P is a N*N transition matrix (elements of  P
+        are non-negative, each column sums to 1.0).
+
+        Such models arise when when:
+        * there is some population of individuals
+        * individuals can have different states
+        * individuals can transit from one state to another
+        * population size is constant, i.e. there is no new individuals and no one
+          leaves population
+        * you want to model transitions of individuals from one state into another
+
+        USAGE:
+
+        Here we give very brief outline of the MCPD. We strongly recommend you  to
+        read examples in the ALGLIB Reference Manual and to read ALGLIB User Guide
+        on data analysis which is available at http://www.alglib.net/dataanalysis/
+
+        1. User initializes algorithm state with MCPDCreate() call
+
+        2. User  adds  one  or  more  tracks -  sequences of states which describe
+           evolution of a system being modelled from different starting conditions
+
+        3. User may add optional boundary, equality  and/or  linear constraints on
+           the coefficients of P by calling one of the following functions:
+           * MCPDSetEC() to set equality constraints
+           * MCPDSetBC() to set bound constraints
+           * MCPDSetLC() to set linear constraints
+
+        4. Optionally,  user  may  set  custom  weights  for prediction errors (by
+           default, algorithm assigns non-equal, automatically chosen weights  for
+           errors in the prediction of different components of X). It can be  done
+           with a call of MCPDSetPredictionWeights() function.
+
+        5. User calls MCPDSolve() function which takes algorithm  state and
+           pointer (delegate, etc.) to callback function which calculates F/G.
+
+        6. User calls MCPDResults() to get solution
+
+        INPUT PARAMETERS:
+            N       -   problem dimension, N>=1
+
+        OUTPUT PARAMETERS:
+            State   -   structure stores algorithm state
 
           -- ALGLIB --
-             Copyright 04.11.2007 by Bochkanov Sergey
+             Copyright 23.05.2010 by Bochkanov Sergey
         *************************************************************************/
-        public static void mlpcreate1(int nin,
-            int nhid,
-            int nout,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-
-            layerscount = 1+3+2;
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, false, network);
+        public static void mcpdcreate(int n,
+            mcpdstate s)
+        {
+            ap.assert(n>=1, "MCPDCreate: N<1");
+            mcpdinit(n, -1, -1, s);
         }
 
 
         /*************************************************************************
-        Same as MLPCreate0, but with two hidden layers (NHid1 and  NHid2  neurons)
-        with non-linear activation function. Output layer is linear.
-         $ALL
+        DESCRIPTION:
+
+        This function is a specialized version of MCPDCreate()  function,  and  we
+        recommend  you  to read comments for this function for general information
+        about MCPD solver.
+
+        This  function  creates  MCPD (Markov Chains for Population  Data)  solver
+        for "Entry-state" model,  i.e. model  where transition from X[i] to X[i+1]
+        is modelled as
+            X[i+1] = P*X[i]
+        where
+            X[i] and X[i+1] are N-dimensional state vectors
+            P is a N*N transition matrix
+        and  one  selected component of X[] is called "entry" state and is treated
+        in a special way:
+            system state always transits from "entry" state to some another state
+            system state can not transit from any state into "entry" state
+        Such conditions basically mean that row of P which corresponds to  "entry"
+        state is zero.
+
+        Such models arise when:
+        * there is some population of individuals
+        * individuals can have different states
+        * individuals can transit from one state to another
+        * population size is NOT constant -  at every moment of time there is some
+          (unpredictable) amount of "new" individuals, which can transit into  one
+          of the states at the next turn, but still no one leaves population
+        * you want to model transitions of individuals from one state into another
+        * but you do NOT want to predict amount of "new"  individuals  because  it
+          does not depends on individuals already present (hence  system  can  not
+          transit INTO entry state - it can only transit FROM it).
+
+        This model is discussed  in  more  details  in  the ALGLIB User Guide (see
+        http://www.alglib.net/dataanalysis/ for more data).
+
+        INPUT PARAMETERS:
+            N       -   problem dimension, N>=2
+            EntryState- index of entry state, in 0..N-1
+
+        OUTPUT PARAMETERS:
+            State   -   structure stores algorithm state
 
           -- ALGLIB --
-             Copyright 04.11.2007 by Bochkanov Sergey
+             Copyright 23.05.2010 by Bochkanov Sergey
         *************************************************************************/
-        public static void mlpcreate2(int nin,
-            int nhid1,
-            int nhid2,
-            int nout,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-
-            layerscount = 1+3+3+2;
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid2, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, false, network);
+        public static void mcpdcreateentry(int n,
+            int entrystate,
+            mcpdstate s)
+        {
+            ap.assert(n>=2, "MCPDCreateEntry: N<2");
+            ap.assert(entrystate>=0, "MCPDCreateEntry: EntryState<0");
+            ap.assert(entrystate<n, "MCPDCreateEntry: EntryState>=N");
+            mcpdinit(n, entrystate, -1, s);
         }
 
 
         /*************************************************************************
-        Creates  neural  network  with  NIn  inputs,  NOut outputs, without hidden
-        layers with non-linear output layer. Network weights are filled with small
-        random values.
-
-        Activation function of the output layer takes values:
-
-            (B, +INF), if D>=0
-
-        or
-
-            (-INF, B), if D<0.
-
+        DESCRIPTION:
+
+        This function is a specialized version of MCPDCreate()  function,  and  we
+        recommend  you  to read comments for this function for general information
+        about MCPD solver.
+
+        This  function  creates  MCPD (Markov Chains for Population  Data)  solver
+        for "Exit-state" model,  i.e. model  where  transition from X[i] to X[i+1]
+        is modelled as
+            X[i+1] = P*X[i]
+        where
+            X[i] and X[i+1] are N-dimensional state vectors
+            P is a N*N transition matrix
+        and  one  selected component of X[] is called "exit"  state and is treated
+        in a special way:
+            system state can transit from any state into "exit" state
+            system state can not transit from "exit" state into any other state
+            transition operator discards "exit" state (makes it zero at each turn)
+        Such  conditions  basically  mean  that  column  of P which corresponds to
+        "exit" state is zero. Multiplication by such P may decrease sum of  vector
+        components.
+
+        Such models arise when:
+        * there is some population of individuals
+        * individuals can have different states
+        * individuals can transit from one state to another
+        * population size is NOT constant - individuals can move into "exit" state
+          and leave population at the next turn, but there are no new individuals
+        * amount of individuals which leave population can be predicted
+        * you want to model transitions of individuals from one state into another
+          (including transitions into the "exit" state)
+
+        This model is discussed  in  more  details  in  the ALGLIB User Guide (see
+        http://www.alglib.net/dataanalysis/ for more data).
+
+        INPUT PARAMETERS:
+            N       -   problem dimension, N>=2
+            ExitState-  index of exit state, in 0..N-1
+
+        OUTPUT PARAMETERS:
+            State   -   structure stores algorithm state
 
           -- ALGLIB --
-             Copyright 30.03.2008 by Bochkanov Sergey
+             Copyright 23.05.2010 by Bochkanov Sergey
         *************************************************************************/
-        public static void mlpcreateb0(int nin,
-            int nout,
-            double b,
-            double d,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-            int i = 0;
-
-            layerscount = 1+3;
-            if( (double)(d)>=(double)(0) )
-            {
-                d = 1;
-            }
-            else
-            {
-                d = -1;
-            }
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(3, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, false, network);
-            
-            //
-            // Turn on ouputs shift/scaling.
-            //
-            for(i=nin; i<=nin+nout-1; i++)
-            {
-                network.columnmeans[i] = b;
-                network.columnsigmas[i] = d;
-            }
+        public static void mcpdcreateexit(int n,
+            int exitstate,
+            mcpdstate s)
+        {
+            ap.assert(n>=2, "MCPDCreateExit: N<2");
+            ap.assert(exitstate>=0, "MCPDCreateExit: ExitState<0");
+            ap.assert(exitstate<n, "MCPDCreateExit: ExitState>=N");
+            mcpdinit(n, -1, exitstate, s);
         }
 
 
         /*************************************************************************
-        Same as MLPCreateB0 but with non-linear hidden layer.
+        DESCRIPTION:
+
+        This function is a specialized version of MCPDCreate()  function,  and  we
+        recommend  you  to read comments for this function for general information
+        about MCPD solver.
+
+        This  function  creates  MCPD (Markov Chains for Population  Data)  solver
+        for "Entry-Exit-states" model, i.e. model where  transition  from  X[i] to
+        X[i+1] is modelled as
+            X[i+1] = P*X[i]
+        where
+            X[i] and X[i+1] are N-dimensional state vectors
+            P is a N*N transition matrix
+        one selected component of X[] is called "entry" state and is treated in  a
+        special way:
+            system state always transits from "entry" state to some another state
+            system state can not transit from any state into "entry" state
+        and another one component of X[] is called "exit" state and is treated  in
+        a special way too:
+            system state can transit from any state into "exit" state
+            system state can not transit from "exit" state into any other state
+            transition operator discards "exit" state (makes it zero at each turn)
+        Such conditions basically mean that:
+            row of P which corresponds to "entry" state is zero
+            column of P which corresponds to "exit" state is zero
+        Multiplication by such P may decrease sum of vector components.
+
+        Such models arise when:
+        * there is some population of individuals
+        * individuals can have different states
+        * individuals can transit from one state to another
+        * population size is NOT constant
+        * at every moment of time there is some (unpredictable)  amount  of  "new"
+          individuals, which can transit into one of the states at the next turn
+        * some  individuals  can  move  (predictably)  into "exit" state and leave
+          population at the next turn
+        * you want to model transitions of individuals from one state into another,
+          including transitions from the "entry" state and into the "exit" state.
+        * but you do NOT want to predict amount of "new"  individuals  because  it
+          does not depends on individuals already present (hence  system  can  not
+          transit INTO entry state - it can only transit FROM it).
+
+        This model is discussed  in  more  details  in  the ALGLIB User Guide (see
+        http://www.alglib.net/dataanalysis/ for more data).
+
+        INPUT PARAMETERS:
+            N       -   problem dimension, N>=2
+            EntryState- index of entry state, in 0..N-1
+            ExitState-  index of exit state, in 0..N-1
+
+        OUTPUT PARAMETERS:
+            State   -   structure stores algorithm state
 
           -- ALGLIB --
-             Copyright 30.03.2008 by Bochkanov Sergey
+             Copyright 23.05.2010 by Bochkanov Sergey
         *************************************************************************/
-        public static void mlpcreateb1(int nin,
-            int nhid,
-            int nout,
-            double b,
-            double d,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-            int i = 0;
-
-            layerscount = 1+3+3;
-            if( (double)(d)>=(double)(0) )
-            {
-                d = 1;
-            }
-            else
-            {
-                d = -1;
-            }
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(3, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, false, network);
-            
-            //
-            // Turn on ouputs shift/scaling.
-            //
-            for(i=nin; i<=nin+nout-1; i++)
-            {
-                network.columnmeans[i] = b;
-                network.columnsigmas[i] = d;
-            }
+        public static void mcpdcreateentryexit(int n,
+            int entrystate,
+            int exitstate,
+            mcpdstate s)
+        {
+            ap.assert(n>=2, "MCPDCreateEntryExit: N<2");
+            ap.assert(entrystate>=0, "MCPDCreateEntryExit: EntryState<0");
+            ap.assert(entrystate<n, "MCPDCreateEntryExit: EntryState>=N");
+            ap.assert(exitstate>=0, "MCPDCreateEntryExit: ExitState<0");
+            ap.assert(exitstate<n, "MCPDCreateEntryExit: ExitState>=N");
+            ap.assert(entrystate!=exitstate, "MCPDCreateEntryExit: EntryState=ExitState");
+            mcpdinit(n, entrystate, exitstate, s);
         }
 
 
         /*************************************************************************
-        Same as MLPCreateB0 but with two non-linear hidden layers.
+        This  function  is  used to add a track - sequence of system states at the
+        different moments of its evolution.
+
+        You  may  add  one  or several tracks to the MCPD solver. In case you have
+        several tracks, they won't overwrite each other. For example,  if you pass
+        two tracks, A1-A2-A3 (system at t=A+1, t=A+2 and t=A+3) and B1-B2-B3, then
+        solver will try to model transitions from t=A+1 to t=A+2, t=A+2 to  t=A+3,
+        t=B+1 to t=B+2, t=B+2 to t=B+3. But it WONT mix these two tracks - i.e. it
+        wont try to model transition from t=A+3 to t=B+1.
+
+        INPUT PARAMETERS:
+            S       -   solver
+            XY      -   track, array[K,N]:
+                        * I-th row is a state at t=I
+                        * elements of XY must be non-negative (exception will be
+                          thrown on negative elements)
+            K       -   number of points in a track
+                        * if given, only leading K rows of XY are used
+                        * if not given, automatically determined from size of XY
+
+        NOTES:
+
+        1. Track may contain either proportional or population data:
+           * with proportional data all rows of XY must sum to 1.0, i.e. we have
+             proportions instead of absolute population values
+           * with population data rows of XY contain population counts and generally
+             do not sum to 1.0 (although they still must be non-negative)
 
           -- ALGLIB --
-             Copyright 30.03.2008 by Bochkanov Sergey
+             Copyright 23.05.2010 by Bochkanov Sergey
         *************************************************************************/
-        public static void mlpcreateb2(int nin,
-            int nhid1,
-            int nhid2,
-            int nout,
-            double b,
-            double d,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-            int i = 0;
-
-            layerscount = 1+3+3+3;
-            if( (double)(d)>=(double)(0) )
-            {
-                d = 1;
-            }
-            else
-            {
-                d = -1;
-            }
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid2, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(3, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, false, network);
-            
-            //
-            // Turn on ouputs shift/scaling.
-            //
-            for(i=nin; i<=nin+nout-1; i++)
-            {
-                network.columnmeans[i] = b;
-                network.columnsigmas[i] = d;
-            }
-        }
-
-
-        /*************************************************************************
-        Creates  neural  network  with  NIn  inputs,  NOut outputs, without hidden
-        layers with non-linear output layer. Network weights are filled with small
-        random values. Activation function of the output layer takes values [A,B].
-
-          -- ALGLIB --
-             Copyright 30.03.2008 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpcreater0(int nin,
-            int nout,
-            double a,
-            double b,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-            int i = 0;
-
-            layerscount = 1+3;
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, false, network);
-            
-            //
-            // Turn on outputs shift/scaling.
-            //
-            for(i=nin; i<=nin+nout-1; i++)
-            {
-                network.columnmeans[i] = 0.5*(a+b);
-                network.columnsigmas[i] = 0.5*(a-b);
-            }
-        }
-
-
-        /*************************************************************************
-        Same as MLPCreateR0, but with non-linear hidden layer.
-
-          -- ALGLIB --
-             Copyright 30.03.2008 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpcreater1(int nin,
-            int nhid,
-            int nout,
-            double a,
-            double b,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-            int i = 0;
-
-            layerscount = 1+3+3;
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, false, network);
-            
-            //
-            // Turn on outputs shift/scaling.
-            //
-            for(i=nin; i<=nin+nout-1; i++)
-            {
-                network.columnmeans[i] = 0.5*(a+b);
-                network.columnsigmas[i] = 0.5*(a-b);
-            }
-        }
-
-
-        /*************************************************************************
-        Same as MLPCreateR0, but with two non-linear hidden layers.
-
-          -- ALGLIB --
-             Copyright 30.03.2008 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpcreater2(int nin,
-            int nhid1,
-            int nhid2,
-            int nout,
-            double a,
-            double b,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-            int i = 0;
-
-            layerscount = 1+3+3+3;
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid2, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, false, network);
-            
-            //
-            // Turn on outputs shift/scaling.
-            //
-            for(i=nin; i<=nin+nout-1; i++)
-            {
-                network.columnmeans[i] = 0.5*(a+b);
-                network.columnsigmas[i] = 0.5*(a-b);
-            }
-        }
-
-
-        /*************************************************************************
-        Creates classifier network with NIn  inputs  and  NOut  possible  classes.
-        Network contains no hidden layers and linear output  layer  with  SOFTMAX-
-        normalization  (so  outputs  sums  up  to  1.0  and  converge to posterior
-        probabilities).
-
-          -- ALGLIB --
-             Copyright 04.11.2007 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpcreatec0(int nin,
-            int nout,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-
-            ap.assert(nout>=2, "MLPCreateC0: NOut<2!");
-            layerscount = 1+2+1;
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout-1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addzerolayer(ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, true, network);
-        }
-
-
-        /*************************************************************************
-        Same as MLPCreateC0, but with one non-linear hidden layer.
-
-          -- ALGLIB --
-             Copyright 04.11.2007 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpcreatec1(int nin,
-            int nhid,
-            int nout,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-
-            ap.assert(nout>=2, "MLPCreateC1: NOut<2!");
-            layerscount = 1+3+2+1;
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout-1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addzerolayer(ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, true, network);
-        }
-
-
-        /*************************************************************************
-        Same as MLPCreateC0, but with two non-linear hidden layers.
-
-          -- ALGLIB --
-             Copyright 04.11.2007 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpcreatec2(int nin,
-            int nhid1,
-            int nhid2,
-            int nout,
-            multilayerperceptron network)
-        {
-            int[] lsizes = new int[0];
-            int[] ltypes = new int[0];
-            int[] lconnfirst = new int[0];
-            int[] lconnlast = new int[0];
-            int layerscount = 0;
-            int lastproc = 0;
-
-            ap.assert(nout>=2, "MLPCreateC2: NOut<2!");
-            layerscount = 1+3+3+2+1;
-            
-            //
-            // Allocate arrays
-            //
-            lsizes = new int[layerscount-1+1];
-            ltypes = new int[layerscount-1+1];
-            lconnfirst = new int[layerscount-1+1];
-            lconnlast = new int[layerscount-1+1];
-            
-            //
-            // Layers
-            //
-            addinputlayer(nin, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nhid2, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addactivationlayer(1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addbiasedsummatorlayer(nout-1, ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            addzerolayer(ref lsizes, ref ltypes, ref lconnfirst, ref lconnlast, ref lastproc);
-            
-            //
-            // Create
-            //
-            mlpcreate(nin, nout, lsizes, ltypes, lconnfirst, lconnlast, layerscount, true, network);
-        }
-
-
-        /*************************************************************************
-        Copying of neural network
-
-        INPUT PARAMETERS:
-            Network1 -   original
-
-        OUTPUT PARAMETERS:
-            Network2 -   copy
-
-          -- ALGLIB --
-             Copyright 04.11.2007 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpcopy(multilayerperceptron network1,
-            multilayerperceptron network2)
-        {
-            int i = 0;
-            int ssize = 0;
-            int ntotal = 0;
-            int nin = 0;
-            int nout = 0;
-            int wcount = 0;
-            int i_ = 0;
-
-            
-            //
-            // Unload info
-            //
-            ssize = network1.structinfo[0];
-            nin = network1.structinfo[1];
-            nout = network1.structinfo[2];
-            ntotal = network1.structinfo[3];
-            wcount = network1.structinfo[4];
-            
-            //
-            // Allocate space
-            //
-            network2.structinfo = new int[ssize-1+1];
-            network2.weights = new double[wcount-1+1];
-            if( mlpissoftmax(network1) )
-            {
-                network2.columnmeans = new double[nin-1+1];
-                network2.columnsigmas = new double[nin-1+1];
-            }
-            else
-            {
-                network2.columnmeans = new double[nin+nout-1+1];
-                network2.columnsigmas = new double[nin+nout-1+1];
-            }
-            network2.neurons = new double[ntotal-1+1];
-            network2.chunks = new double[3*ntotal+1, chunksize-1+1];
-            network2.nwbuf = new double[Math.Max(wcount, 2*nout)-1+1];
-            network2.dfdnet = new double[ntotal-1+1];
-            network2.x = new double[nin-1+1];
-            network2.y = new double[nout-1+1];
-            network2.derror = new double[ntotal-1+1];
-            
-            //
-            // Copy
-            //
-            for(i=0; i<=ssize-1; i++)
-            {
-                network2.structinfo[i] = network1.structinfo[i];
-            }
-            for(i_=0; i_<=wcount-1;i_++)
-            {
-                network2.weights[i_] = network1.weights[i_];
-            }
-            if( mlpissoftmax(network1) )
-            {
-                for(i_=0; i_<=nin-1;i_++)
-                {
-                    network2.columnmeans[i_] = network1.columnmeans[i_];
-                }
-                for(i_=0; i_<=nin-1;i_++)
-                {
-                    network2.columnsigmas[i_] = network1.columnsigmas[i_];
-                }
-            }
-            else
-            {
-                for(i_=0; i_<=nin+nout-1;i_++)
-                {
-                    network2.columnmeans[i_] = network1.columnmeans[i_];
-                }
-                for(i_=0; i_<=nin+nout-1;i_++)
-                {
-                    network2.columnsigmas[i_] = network1.columnsigmas[i_];
-                }
-            }
-            for(i_=0; i_<=ntotal-1;i_++)
-            {
-                network2.neurons[i_] = network1.neurons[i_];
-            }
-            for(i_=0; i_<=ntotal-1;i_++)
-            {
-                network2.dfdnet[i_] = network1.dfdnet[i_];
-            }
-            for(i_=0; i_<=nin-1;i_++)
-            {
-                network2.x[i_] = network1.x[i_];
-            }
-            for(i_=0; i_<=nout-1;i_++)
-            {
-                network2.y[i_] = network1.y[i_];
-            }
-            for(i_=0; i_<=ntotal-1;i_++)
-            {
-                network2.derror[i_] = network1.derror[i_];
-            }
-        }
-
-
-        /*************************************************************************
-        Serialization of MultiLayerPerceptron strucure
-
-        INPUT PARAMETERS:
-            Network -   original
-
-        OUTPUT PARAMETERS:
-            RA      -   array of real numbers which stores network,
-                        array[0..RLen-1]
-            RLen    -   RA lenght
-
-          -- ALGLIB --
-             Copyright 29.03.2008 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpserialize(multilayerperceptron network,
-            ref double[] ra,
-            ref int rlen)
-        {
-            int i = 0;
-            int ssize = 0;
-            int ntotal = 0;
-            int nin = 0;
-            int nout = 0;
-            int wcount = 0;
-            int sigmalen = 0;
-            int offs = 0;
-            int i_ = 0;
-            int i1_ = 0;
-
-            ra = new double[0];
-            rlen = 0;
-
-            
-            //
-            // Unload info
-            //
-            ssize = network.structinfo[0];
-            nin = network.structinfo[1];
-            nout = network.structinfo[2];
-            ntotal = network.structinfo[3];
-            wcount = network.structinfo[4];
-            if( mlpissoftmax(network) )
-            {
-                sigmalen = nin;
-            }
-            else
-            {
-                sigmalen = nin+nout;
-            }
-            
-            //
-            //  RA format:
-            //      LEN         DESRC.
-            //      1           RLen
-            //      1           version (MLPVNum)
-            //      1           StructInfo size
-            //      SSize       StructInfo
-            //      WCount      Weights
-            //      SigmaLen    ColumnMeans
-            //      SigmaLen    ColumnSigmas
-            //
-            rlen = 3+ssize+wcount+2*sigmalen;
-            ra = new double[rlen-1+1];
-            ra[0] = rlen;
-            ra[1] = mlpvnum;
-            ra[2] = ssize;
-            offs = 3;
-            for(i=0; i<=ssize-1; i++)
-            {
-                ra[offs+i] = network.structinfo[i];
-            }
-            offs = offs+ssize;
-            i1_ = (0) - (offs);
-            for(i_=offs; i_<=offs+wcount-1;i_++)
-            {
-                ra[i_] = network.weights[i_+i1_];
-            }
-            offs = offs+wcount;
-            i1_ = (0) - (offs);
-            for(i_=offs; i_<=offs+sigmalen-1;i_++)
-            {
-                ra[i_] = network.columnmeans[i_+i1_];
-            }
-            offs = offs+sigmalen;
-            i1_ = (0) - (offs);
-            for(i_=offs; i_<=offs+sigmalen-1;i_++)
-            {
-                ra[i_] = network.columnsigmas[i_+i1_];
-            }
-            offs = offs+sigmalen;
-        }
-
-
-        /*************************************************************************
-        Unserialization of MultiLayerPerceptron strucure
-
-        INPUT PARAMETERS:
-            RA      -   real array which stores network
-
-        OUTPUT PARAMETERS:
-            Network -   restored network
-
-          -- ALGLIB --
-             Copyright 29.03.2008 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpunserialize(double[] ra,
-            multilayerperceptron network)
-        {
-            int i = 0;
-            int ssize = 0;
-            int ntotal = 0;
-            int nin = 0;
-            int nout = 0;
-            int wcount = 0;
-            int sigmalen = 0;
-            int offs = 0;
-            int i_ = 0;
-            int i1_ = 0;
-
-            ap.assert((int)Math.Round(ra[1])==mlpvnum, "MLPUnserialize: incorrect array!");
-            
-            //
-            // Unload StructInfo from IA
-            //
-            offs = 3;
-            ssize = (int)Math.Round(ra[2]);
-            network.structinfo = new int[ssize-1+1];
-            for(i=0; i<=ssize-1; i++)
-            {
-                network.structinfo[i] = (int)Math.Round(ra[offs+i]);
-            }
-            offs = offs+ssize;
-            
-            //
-            // Unload info from StructInfo
-            //
-            ssize = network.structinfo[0];
-            nin = network.structinfo[1];
-            nout = network.structinfo[2];
-            ntotal = network.structinfo[3];
-            wcount = network.structinfo[4];
-            if( network.structinfo[6]==0 )
-            {
-                sigmalen = nin+nout;
-            }
-            else
-            {
-                sigmalen = nin;
-            }
-            
-            //
-            // Allocate space for other fields
-            //
-            network.weights = new double[wcount-1+1];
-            network.columnmeans = new double[sigmalen-1+1];
-            network.columnsigmas = new double[sigmalen-1+1];
-            network.neurons = new double[ntotal-1+1];
-            network.chunks = new double[3*ntotal+1, chunksize-1+1];
-            network.nwbuf = new double[Math.Max(wcount, 2*nout)-1+1];
-            network.dfdnet = new double[ntotal-1+1];
-            network.x = new double[nin-1+1];
-            network.y = new double[nout-1+1];
-            network.derror = new double[ntotal-1+1];
-            
-            //
-            // Copy parameters from RA
-            //
-            i1_ = (offs) - (0);
-            for(i_=0; i_<=wcount-1;i_++)
-            {
-                network.weights[i_] = ra[i_+i1_];
-            }
-            offs = offs+wcount;
-            i1_ = (offs) - (0);
-            for(i_=0; i_<=sigmalen-1;i_++)
-            {
-                network.columnmeans[i_] = ra[i_+i1_];
-            }
-            offs = offs+sigmalen;
-            i1_ = (offs) - (0);
-            for(i_=0; i_<=sigmalen-1;i_++)
-            {
-                network.columnsigmas[i_] = ra[i_+i1_];
-            }
-            offs = offs+sigmalen;
-        }
-
-
-        /*************************************************************************
-        Randomization of neural network weights
-
-          -- ALGLIB --
-             Copyright 06.11.2007 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlprandomize(multilayerperceptron network)
-        {
-            int i = 0;
-            int nin = 0;
-            int nout = 0;
-            int wcount = 0;
-
-            mlpproperties(network, ref nin, ref nout, ref wcount);
-            for(i=0; i<=wcount-1; i++)
-            {
-                network.weights[i] = math.randomreal()-0.5;
-            }
-        }
-
-
-        /*************************************************************************
-        Randomization of neural network weights and standartisator
-
-          -- ALGLIB --
-             Copyright 10.03.2008 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlprandomizefull(multilayerperceptron network)
-        {
-            int i = 0;
-            int nin = 0;
-            int nout = 0;
-            int wcount = 0;
-            int ntotal = 0;
-            int istart = 0;
-            int offs = 0;
-            int ntype = 0;
-
-            mlpproperties(network, ref nin, ref nout, ref wcount);
-            ntotal = network.structinfo[3];
-            istart = network.structinfo[5];
-            
-            //
-            // Process network
-            //
-            for(i=0; i<=wcount-1; i++)
-            {
-                network.weights[i] = math.randomreal()-0.5;
-            }
-            for(i=0; i<=nin-1; i++)
-            {
-                network.columnmeans[i] = 2*math.randomreal()-1;
-                network.columnsigmas[i] = 1.5*math.randomreal()+0.5;
-            }
-            if( !mlpissoftmax(network) )
-            {
-                for(i=0; i<=nout-1; i++)
-                {
-                    offs = istart+(ntotal-nout+i)*nfieldwidth;
-                    ntype = network.structinfo[offs+0];
-                    if( ntype==0 )
-                    {
-                        
-                        //
-                        // Shifts are changed only for linear outputs neurons
-                        //
-                        network.columnmeans[nin+i] = 2*math.randomreal()-1;
-                    }
-                    if( ntype==0 | ntype==3 )
-                    {
-                        
-                        //
-                        // Scales are changed only for linear or bounded outputs neurons.
-                        // Note that scale randomization preserves sign.
-                        //
-                        network.columnsigmas[nin+i] = Math.Sign(network.columnsigmas[nin+i])*(1.5*math.randomreal()+0.5);
-                    }
-                }
-            }
-        }
-
-
-        /*************************************************************************
-        Internal subroutine.
-
-          -- ALGLIB --
-             Copyright 30.03.2008 by Bochkanov Sergey
-        *************************************************************************/
-        public static void mlpinitpreprocessor(multilayerperceptron network,
+        public static void mcpdaddtrack(mcpdstate s,
             double[,] xy,
-            int ssize)
+            int k)
         {
             int i = 0;
             int j = 0;
-            int jmax = 0;
-            int nin = 0;
-            int nout = 0;
-            int wcount = 0;
-            int ntotal = 0;
-            int istart = 0;
-            int offs = 0;
-            int ntype = 0;
-            double[] means = new double[0];
-            double[] sigmas = new double[0];
-            double s = 0;
-
-            mlpproperties(network, ref nin, ref nout, ref wcount);
-            ntotal = network.structinfo[3];
-            istart = network.structinfo[5];
-            
-            //
-            // Means/Sigmas
-            //
-            if( mlpissoftmax(network) )
-            {
-                jmax = nin-1;
-            }
-            else
-            {
-                jmax = nin+nout-1;
-            }
-            means = new double[jmax+1];
-            sigmas = new double[jmax+1];
-            for(j=0; j<=jmax; j++)
-            {
-                means[j] = 0;
-                for(i=0; i<=ssize-1; i++)
-                {
-                    means[j] = means[j]+xy[i,j];
-                }
-                means[j] = means[j]/ssize;
-                sigmas[j] = 0;
-                for(i=0; i<=ssize-1; i++)
-                {
-                    sigmas[j] = sigmas[j]+math.sqr(xy[i,j]-means[j]);
-                }
-                sigmas[j] = Math.Sqrt(sigmas[j]/ssize);
-            }
-            
-            //
-            // Inputs
-            //
-            for(i=0; i<=nin-1; i++)
-            {
-                network.columnmeans[i] = means[i];
-                network.columnsigmas[i] = sigmas[i];
-                if( (double)(network.columnsigmas[i])==(double)(0) )
-                {
-                    network.columnsigmas[i] = 1;
-                }
-            }
-            
-            //
-            // Outputs
-            //
-            if( !mlpissoftmax(network) )
-            {
-                for(i=0; i<=nout-1; i++)
-                {
-                    offs = istart+(ntotal-nout+i)*nfieldwidth;
-                    ntype = network.structinfo[offs+0];
-                    
-                    //
-                    // Linear outputs
-                    //
-                    if( ntype==0 )
-                    {
-                        network.columnmeans[nin+i] = means[nin+i];
-                        network.columnsigmas[nin+i] = sigmas[nin+i];
-                        if( (double)(network.columnsigmas[nin+i])==(double)(0) )
+            int n = 0;
+            double s0 = 0;
+            double s1 = 0;
+
+            n = s.n;
+            ap.assert(k>=0, "MCPDAddTrack: K<0");
+            ap.assert(ap.cols(xy)>=n, "MCPDAddTrack: Cols(XY)<N");
+            ap.assert(ap.rows(xy)>=k, "MCPDAddTrack: Rows(XY)<K");
+            ap.assert(apserv.apservisfinitematrix(xy, k, n), "MCPDAddTrack: XY contains infinite or NaN elements");
+            for(i=0; i<=k-1; i++)
+            {
+                for(j=0; j<=n-1; j++)
+                {
+                    ap.assert((double)(xy[i,j])>=(double)(0), "MCPDAddTrack: XY contains negative elements");
+                }
+            }
+            if( k<2 )
+            {
+                return;
+            }
+            if( ap.rows(s.data)<s.npairs+k-1 )
+            {
+                apserv.rmatrixresize(ref s.data, Math.Max(2*ap.rows(s.data), s.npairs+k-1), 2*n);
+            }
+            for(i=0; i<=k-2; i++)
+            {
+                s0 = 0;
+                s1 = 0;
+                for(j=0; j<=n-1; j++)
+                {
+                    if( s.states[j]>=0 )
+                    {
+                        s0 = s0+xy[i,j];
+                    }
+                    if( s.states[j]<=0 )
+                    {
+                        s1 = s1+xy[i+1,j];
+                    }
+                }
+                if( (double)(s0)>(double)(0) & (double)(s1)>(double)(0) )
+                {
+                    for(j=0; j<=n-1; j++)
+                    {
+                        if( s.states[j]>=0 )
                         {
-                            network.columnsigmas[nin+i] = 1;
+                            s.data[s.npairs,j] = xy[i,j]/s0;
                         }
-                    }
-                    
-                    //
-                    // Bounded outputs (half-interval)
-                    //
-                    if( ntype==3 )
-                    {
-                        s = means[nin+i]-network.columnmeans[nin+i];
-                        if( (double)(s)==(double)(0) )
+                        else
                         {
-                            s = Math.Sign(network.columnsigmas[nin+i]);
+                            s.data[s.npairs,j] = 0.0;
                         }
-                        if( (double)(s)==(double)(0) )
+                        if( s.states[j]<=0 )
                         {
-                            s = 1.0;
+                            s.data[s.npairs,n+j] = xy[i+1,j]/s1;
                         }
-                        network.columnsigmas[nin+i] = Math.Sign(network.columnsigmas[nin+i])*Math.Abs(s);
-                        if( (double)(network.columnsigmas[nin+i])==(double)(0) )
+                        else
                         {
-                            network.columnsigmas[nin+i] = 1;
+                            s.data[s.npairs,n+j] = 0.0;
                         }
                     }
+                    s.npairs = s.npairs+1;
                 }
             }
